bomb = class:new()

function bomb:init(args)
	self.x = args[1]-13
	self.y = args[2]-13
	self.w = 20
	self.h = 20
	self.px = self.x
	self.py = self.y
	
	local dx = (self.x)-(obj[1].x)
	local dy = (self.y)-(obj[1].y)
	
	local ang = angle:new({dx, dy})
	self.vx = -ang.xPart*780
	self.vy = ang.yPart*780
	
	self.die = false
	self.col = false
	self.id = "bomb"
	if self.vx >= 0 then self.img = img["bomb_r"]; self.ox = 0; self.oy = 0
	else self.img = img["bomb_l"]; self.ox = 6; self.oy = 0 end
	
	self.add = {}
	self.alpha = 255
	
	self.stuck = false
	self.timer = 1.5
	self.boomed = false
	self.booms = {}
	self.boomTimer = 0
	
	self.imgTimer = 0.2
	self.imgNum = 1
end

function bomb:update(dt)
	self.px = self.x
	self.py = self.y
	
	self.add = {}
	
	if (not self.stuck) or intro then
		self.x = self.x + self.vx*dt
		self.y = self.y + self.vy*dt
	end
	if self.stuck then
		self.timer = self.timer - dt
		if self.timer < 0 then
			self.die = true
			for i=1, table.getn(obj) do
				if obj[i].id == "crash" and obj[i].shots > 0 then obj[i].shots = obj[i].shots - 1 end
			end
		end
		self.imgTimer = self.imgTimer - dt
		if self.imgTimer < 0 then
			if self.imgNum == 1 then self.imgNum = 2 else self.imgNum = 1 end
			self.imgTimer = self.imgTimer + 0.1
		end
		if self.vx > 0 then self.img = img["bomb"..self.imgNum.."_r"]
		else self.img = img["bomb"..self.imgNum.."_l"] end
		
		--tedious exploding stuff
		if self.timer < 1 then
			if not self.boomed then
				self.w = 100
				self.h = 100
				self.x = self.x - 40
				self.y = self.y - 40
				self.ox = self.ox - 40
				self.oy = self.oy - 40
				self.boomed = true
				explode:play()
			end
			self.boomTimer = self.boomTimer - dt
			if self.boomTimer < 0 then
				self.booms[table.getn(self.booms)+1] = {math.random(self.w)+self.x-16, math.random(self.h)+self.y-16, 0.06, 1}
				self.boomTimer = self.boomTimer + 0.03
			end
			for i=1, table.getn(self.booms) do
				self.booms[i][3] = self.booms[i][3] - dt
				if self.booms[i][3] < 0 then
					self.booms[i][4] = self.booms[i][4] + 1
					if self.booms[i][4] == 2 then self.booms[i][1] = self.booms[i][1] + 4; self.booms[i][2] = self.booms[i][2] + 4 end
					if self.booms[i][4] == 3 then self.booms[i][1] = self.booms[i][1] + 8; self.booms[i][2] = self.booms[i][2] + 8 end
					self.booms[i][3] = self.booms[i][3]+0.06
				end
				if self.booms[i][4] < 4 then self.add[i] = {img["explosion"..self.booms[i][4]], self.booms[i][1], self.booms[i][2], 255}
				else self.add[i] = {img["explosion3"], self.booms[i][1], self.booms[i][2], 0} end
			end
		end
	end
	
	--sticking to sides
	if self.y+self.h/2 > 480-98 and not intro then self.y = 480-98-self.h/2; self:stick() end
	if self.x+self.h/2 < 32 and not intro then self.x = 32-self.h/2; self:stick() end
	if self.x+self.w/2 > 512-32 and not intro then self.x = 512-32-self.w/2; self:stick() end
	
	if intro then self.vy = self.vy + 500*dt end
	
end

function bomb:stick()
	ting:play()
	self.stuck = true
	self.vx = 0
	self.vy = 0
	if self.vx > 0 then self.img = img["bomb1_r"]; self.ox = 0; self.oy = 0
	else self.img = img["bomb1_l"]; self.ox = 0; self.oy = 0 end
end