crash = class:new()

function crash:init(args)
	if obj[1].x+obj[1].w/2 < 256 then
		self.x = 382
		self.dir = -1
		obj[1].dir = 1
	else
		self.x = 130-34
		self.dir = 1
		obj[1].dir = -1
	end
	self.y = -62
	self.px = self.x
	self.py = self.y
	self.w = 34
	self.h = 44
	self.ox = 8
	self.oy = 2
	self.img = img["crash_l"]
	self.alpha = 255
	self.vx = 0
	self.vy = 0
	self.pvy = 0
	self.onGround = false
	self.runCycle = 0
	self.cycleDir = 1
	self.runFrame = 1
	self.jumpTimer = 6 --jump automatically if player does nothing
	self.shooting = false
	self.shootTimer = 0.5
	self.shots = 0
	for i=1, table.getn(obj) do
		if obj[i].id == "bomb" then self.shots = self.shots + 1 end
	end
	self.id = "crash"
	self.hp = 0
	self.invuln = -1
	self.die = false
	self.col = true
	self.add = {}
	self.add[1] = {}
	self.add[1] = {img["pchow"], self.x, self.y}
	self.alpha = 255
	self.pchalpha = 255 --pchow alpha, obviously
end

function crash:update(dt)

	self.php = self.hp
	
	self.px = self.x
	self.py = self.y
	self.pvy = self.vy
	
	self.y = self.y + self.vy*dt
	if not intro then
		self.x = self.x + self.vx*dt
	end
	
	self.vy = self.vy + 1800*dt
	
	
	local pog = self.onGround --on ground last frame?
	self.onGround = false
	
	if self.y+self.h > 480-98 then self.y = 480-98-self.h; self.onGround = true end
	if self.x < 32 then self.x = 32 end
	if self.x+self.w > 512-32 then self.x = 512-32-self.w end
	
	if self.vx == -160 or self.vx == 160 then self.runCycle = self.runCycle + dt end --lies
	if self.runCycle > 0.15 then
		self.runCycle = self.runCycle - 0.15
		self.runFrame = self.runFrame + self.cycleDir
		if self.runFrame > 3 then self.cycleDir = -1; self.runFrame = 2 end
		if self.runFrame < 1 then self.cycleDir = 1; self.runFrame = 2 end
	end
	
	if self.pvy < 40 and self.vy >= 40 and (not intro) then self:shoot() end
	
	self.add = {}
	if self.invuln >= 0 then
		self.invuln = self.invuln - dt
		if self.pchalpha == 255 then self.pchalpha = 0 else self.pchalpha = 255 end
		self.add[1] = {img["pchow"], self.x, self.y, self.pchalpha}
	end
	
	if self.onGround then
		self.vx = self.dir * 150
		if intro then --charge health
			if self.hp == 0 then charge:play() end
			self.hp = self.hp + 15*dt
			if self.hp > 28 then self.hp = 28; intro = false; charge:stop() end
		end
		if not pog then --just landed on ground
			self.jumpTimer = 6
		end
	end
	if self.x < 96 then self.dir = 1 end
	if self.x+self.w > 512-96 then self.dir = -1 end
	
	--jump automatically after 6 seconds
	if self.onGround then self.jumpTimer = self.jumpTimer - dt end
	if self.jumpTimer < 0 then
		self:jump()
	end
	
	self:pickImg()
	
end

function crash:jump()
	if self.onGround then
		self.vx = (math.floor((obj[1].x-self.x)/40)+0.5)*55*1-20
		local rand = math.random(2)-1
		if self.vx > 0 then
			self.vx = self.vx + rand*20*1
		else
			self.vx = self.vx - rand*20*1
		end
		self.vy = -830
	end
end

function crash:shoot()
	if self.shots == 0 then
		self.shooting = true
		self.shootTimer = 0.2
		obj[table.getn(obj)+1] = bomb:new({self.x+self.w/2, self.y+self.h/2})
		self.shots = self.shots + 1
	end
end

function crash:collide(col)
	if obj[col[2]].id == "shot" and self.invuln < 0 then
		--crash man isn't cool enough to have his own loseHP function
		hit:play()
		hits = hits + 1
		self.hp = self.hp - 1
		if self.hp <= 0 then
			die:play()
			self.die = true
			intro = true
			obj[table.getn(obj)+1] = crash:new({})
			kills = kills + 1
			--explode:stop()
			
			for i=1, 3 do --death explosions
				obj[table.getn(obj)+1] = boom:new({self.x+self.w/2, self.y+self.h/2, 50+i*50, 0, (3-i)*0.4, i})
				obj[table.getn(obj)+1] = boom:new({self.x+self.w/2, self.y+self.h/2, -50-i*50, 0, (3-i)*0.4, i})
				obj[table.getn(obj)+1] = boom:new({self.x+self.w/2, self.y+self.h/2, 0, 50+i*50, (3-i)*0.4, i})
				obj[table.getn(obj)+1] = boom:new({self.x+self.w/2, self.y+self.h/2, 0, -50-i*50, (3-i)*0.4, i})
			end
			
		end
		self.invuln = 0.35
		obj[col[2]].die = true
		obj[1].shots = obj[1].shots - 1
	end
end

function crash:pickImg()
	if self.onGround then
		local cycle = (math.floor(self.x/26))%4 + 1
		if cycle == 4 then cycle = 2 end
		if self.vx >= 0 then self.img = img["crash_w"..cycle.."r"]
			if cycle == 1 then self.ox = 10; self.oy = 2 end
			if cycle == 2 then self.ox = -2; self.oy = 4 end -- minus 16
			if cycle == 3 then self.ox = 6; self.oy = 2 end
		end
		if self.vx < 0 then self.img = img["crash_w"..cycle.."l"]
			if cycle == 1 then self.ox = 14; self.oy = 2 end
			if cycle == 2 then self.ox = -2; self.oy = 4 end
			if cycle == 3 then self.ox = 2; self.oy = 2 end
		end
		if intro then
			if self.dir ==  1 then self.img = img["crash_r"]; self.ox = 14; self.oy = 2 end
			if self.dir == -1 then self.img = img["crash_l"]; self.ox = 16; self.oy = 2 end
		end
	else
		if self.vx > 0 or (self.vx==0 and self.dir==1) then self.img = img["crash_j1r"]; self.ox = 4; self.oy = 2 end
		if self.vx < 0 or (self.vx==0 and self.dir==-1) then self.img = img["crash_j1l"]; self.ox = 12; self.oy = 2 end
	end
end