--MONOSPACE FONT LOADER

function loadFont()

	local file = "c64_low.gif"
	--remember to put backslashes before problematic characters
	--local charset = "@abcdefghijklmnopqrstuvwxyz[{]{{ !\"#$\%&'()*+,-./0123456789:;<=>?_ABCDEFGHIJKLMNOPQRSTUVWXYZ{{{{{"
	local charset = [[@abcdefghijklmnopqrstuvwxyz[{]{{ !"#$%&'()*+,-./0123456789:;<=>?_ABCDEFGHIJKLMNOPQRSTUVWXYZ{{{{{]]
	local cw = 16 --char width
	local ch = 16
	local w = 512 --file width
	local h = 48
	local id = love.image.newImageData(file)
	
	chars = {}
	local index = 1
	for i=1, h/ch do
		for j=1, w/cw do --block by block
		
			local imageData = love.image.newImageData(cw, ch)
			
			for x=0, cw-1 do
				for y=0, ch-1 do --pixel by pixel
					--get imagedata from charset
					r, g, b, a = id:getPixel((j-1)*cw+x,(i-1)*ch+y)
					if r == 0 then imageData:setPixel(x,y,255,255,255,255) --note: image should have white background, black characters
					else imageData:setPixel(x,y,255,255,255,0) end
				end
			end
			
			chars[string.sub(charset,index,index)] = love.graphics.newImage(imageData)
			index = index + 1
			
		end
	end
	
end

--returns array "chars" of character images, w/indexes of each character in charset