mega = class:new()

function mega:init(args)
	self.x = 32
	self.y = 200
	self.px = self.x
	self.py = self.y
	self.w = 34
	self.h = 44
	self.ox = 4
	self.oy = 2
	self.img = img["mega_w1r"]
	self.dir = 1
	self.alpha = 255
	self.vx = 0
	self.vy = 0
	self.jumpForce = 560
	self.onGround = false
	self.runCycle = 0
	self.cycleDir = 1
	self.runFrame = 1
	self.shooting = false
	self.shootTimer = 0.5
	self.shots = 0
	self.id = "mega"
	self.hp = 28
	self.invuln = -1
	self.knockbackTime = 1 --duration = two minus this
	self.die = false
	self.col = true
	self.add = {} --additional images
	self.pchalpha = 255 --pchow alpha, obviously
	self.alpha = 255
end

function mega:update(dt)
	self.px = self.x
	self.py = self.y
	
	self.x = self.x + self.vx*dt
	self.y = self.y + self.vy*dt
	
	--falling
	if self.vy < 0 then
		if love.keyboard.isDown("z") and self.invuln < self.knockbackTime and (not intro) then self.vy = self.vy + 1600*dt else self.vy = self.vy + 5000*dt end
	else
		self.vy = self.vy + 1600*dt
	end
	
	--walking
	self.onGround = false
	if self.y+self.h > 480-98 then self.y = 480-98-self.h; self.onGround = true end
	if self.x < 32 then self.x = 32 end
	if self.x+self.w > 512-32 then self.x = 512-32-self.w end
	if (love.keyboard.isDown("left") or love.keyboard.isDown("right")) and self.invuln < self.knockbackTime and (not intro) then
		if (love.keyboard.isDown("left") and love.keyboard.isDown("right")) then self.vx = 0; self.runCycle = 0 else
		if love.keyboard.isDown("left") and self.vx < -80 and self.vx > -160 then self.vx = -160; self.dir = -1 end
		if love.keyboard.isDown("right") and self.vx > 80 and self.vx < 160 then self.vx = 160; self.dir = 1 end
		if love.keyboard.isDown("left") and self.vx >= -80 then
			if self.vx > 0 then self.vx = 0 end
			self.vx = self.vx - 800*dt
			self.dir = -1
		end
		if love.keyboard.isDown("right") and self.vx <= 80 then
			if self.vx < 0 then self.vx = 0 end
			self.vx = self.vx + 800*dt
			self.dir = 1
		end
		end
	end
	if (not (love.keyboard.isDown("left") or love.keyboard.isDown("right"))) or intro then
		if self.vx > 0 then self.vx = 0 end
		if self.vx < 0 then self.vx = 0 end
		self.runCycle = 0
	end
	
	--run cycle
	if self.vx == -160 or self.vx == 160 then self.runCycle = self.runCycle + dt end
	if self.runCycle > 0.15 then
		self.runCycle = self.runCycle - 0.15
		self.runFrame = self.runFrame + self.cycleDir
		if self.runFrame > 3 then self.cycleDir = -1; self.runFrame = 2 end
		if self.runFrame < 1 then self.cycleDir = 1; self.runFrame = 2 end
	end
	
	self.alpha = 255
	--knockback
	if self.invuln > self.knockbackTime then
		self.vx = -self.dir*80
	end
	--invuln
	if self.invuln >= 0 then
		self.invuln = self.invuln - dt
		if self.invuln <= self.knockbackTime then self.alpha = 128 end
	end
	--pchow
	self.add = {}
	if self.invuln >= self.knockbackTime then
		self.invuln = self.invuln - dt
		if self.pchalpha == 255 then self.pchalpha = 0 else self.pchalpha = 255 end
		self.add[1] = {img["pchow"], self.x-4, self.y, self.pchalpha}
	end
	
	if self.shootTimer >= 0 then self.shootTimer = self.shootTimer - dt end
	if self.shootTimer < 0 then self.shooting = false end
	
	self:pickImg()
end

function mega:shoot()
	self.shooting = true
	self.shootTimer = 0.2
	if self.shots < 3 and self.invuln < self.knockbackTime then
		if self.dir == 1 then
			obj[table.getn(obj)+1] = shot:new({self.x+self.w+2, self.y+self.h/2-6, 500})
		else
			obj[table.getn(obj)+1] = shot:new({self.x-16, self.y+self.h/2-6, -500})
		end
		self.shots = self.shots + 1
		shoot:play()
	end
end

function mega:collide(col)
	if obj[col[2]].id == "crash" or obj[col[2]].id == "bomb" then
		self:loseHP()
	end
end

function mega:loseHP()
	if self.invuln < 0 and (not intro) then
	
		dmg:play()
		self.hp = self.hp - 2
		self.invuln = 2
		
		if self.hp == 0 then --die
			self.hp = 28
			mode = "start"
			intro = true
			endGame = true
			fadeout1 = 2
			fadeout2 = 5
			
			--obj = {}
			if kills==1 then endText1 = "YOU KILLED 1 CRASHMAN AT "
			else endText1 = "YOU KILLED "..kills.." CRASHMEN AT " end
			endText2 = (math.floor((kills/(timeElapsed/60))*100)/100).." CRASHMEN PER MINUTE"
		end
		
	end
end

function mega:pickImg()
	if not self.shooting then
	--REGULAR--
	if self.dir == 1 then
		if not self.onGround then
			self.img = img["mega_jr"]; self.ox = 8
		else
			self.ox = 4
			self.oy = 2
			if self.vx == 0 then self.img = img["mega_r"] end
			if self.vx < 50 and self.vx > 0 then self.img = img["mega_sr"] end
			if self.vx == 160 then
				if self.runFrame == 1 then
					self.img = img["mega_w1r"]; self.ox = 8; self.oy = -2
				end
				if self.runFrame == 2 then
					self.img = img["mega_w2r"]; self.ox = 2; self.oy = 2
				end
				if self.runFrame == 3 then
					self.img = img["mega_w3r"]; self.ox = 8; self.oy = -2
				end
			end
		end
	end
	if self.dir == -1 then
		if not self.onGround then
			self.img = img["mega_jl"]; self.ox = 10
		else
			self.ox = 4
			self.oy = 2
			if self.vx == 0 then self.img = img["mega_l"] end
			if self.vx > -50 and self.vx < 0 then self.img = img["mega_sl"]; self.ox = 2 end
			if self.vx == -160 then
				if self.runFrame == 1 then
					self.img = img["mega_w1l"]; self.ox = 6; self.oy = -2
				end
				if self.runFrame == 2 then
					self.img = img["mega_w2l"]; self.ox = -4; self.oy = 2
				end
				if self.runFrame == 3 then
					self.img = img["mega_w3l"]; self.ox = 2; self.oy = -2
				end
			end
		end
	end
	else
	--SHOOTING--
	if self.dir == 1 then --pretend all this is indented
		if not self.onGround then
			self.img = img["mega_fjr"]; self.ox = 8
		else
			self.ox = 4
			self.oy = 2
			if self.vx < 50 then self.img = img["mega_fr"] end
			if self.vx == 160 then
				if self.runFrame == 1 then
					self.img = img["mega_fw1r"]; self.ox = 8; self.oy = -2
				end
				if self.runFrame == 2 then
					self.img = img["mega_fw2r"]; self.ox = 2; self.oy = 2
				end
				if self.runFrame == 3 then
					self.img = img["mega_fw3r"]; self.ox = 8; self.oy = -2
				end
			end
		end
	end
	if self.dir == -1 then
		if not self.onGround then
			self.img = img["mega_fjl"]; self.ox = 16
		else
			self.ox = 26
			self.oy = 2
			if self.vx > -50 then self.img = img["mega_fl"] end
			if self.vx == -160 then
				if self.runCycle > 0.15 then
					self.img = img["mega_fw1l"]; self.ox = 16; self.oy = -2
				else 
					self.img = img["mega_fw2l"]; self.ox = 16; self.oy = 2 end
					
				if self.runFrame == 1 then
					self.img = img["mega_fw1l"]; self.ox = 16; self.oy = -2
				end
				if self.runFrame == 2 then
					self.img = img["mega_fw2l"]; self.ox = 16; self.oy = 2
				end
				if self.runFrame == 3 then
					self.img = img["mega_fw3l"]; self.ox = 19; self.oy = -2
				end
			end
		end
	end
	end
	if self.invuln > self.knockbackTime and self.dir == 1 then
		self.img = img["mega_hr"]; self.ox = 8; self.oy = 2
	end
	if self.invuln > self.knockbackTime and self.dir == -1 then
		self.img = img["mega_hl"]; self.ox = 8; self.oy = 2
	end
end